OGRE-Next: Ogre::SimpleSpline Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Ogre::SimpleSpline Class Reference
Core » Math

A very simple spline class which implements the Catmull-Rom class of splines. More...

`#include <OgreSimpleSpline.h>`

## Public Member Functions
| SimpleSpline ()
| ~SimpleSpline ()
void | addPoint (const Vector3 &p)
| Adds a control point to the end of the spline.
void | clear ()
| Clears all the points in the spline.
unsigned short | getNumPoints () const
| Gets the number of control points in the spline.
const Vector3 & | getPoint (unsigned short index) const
| Gets the detail of one of the control points of the spline.
Vector3 | interpolate (Real t) const
| Returns an interpolated point based on a parametric value over the whole series.
Vector3 | interpolate (unsigned int fromIndex, Real t) const
| Interpolates a single segment of the spline given a parametric value.
void | recalcTangents ()
| Recalculates the tangents associated with this spline.
void | setAutoCalculate (bool autoCalc)
| Tells the spline whether it should automatically calculate tangents on demand as points are added.
void | updatePoint (unsigned short index, const Vector3 &value)
| Updates a single point in the spline.

## Detailed Description

A very simple spline class which implements the Catmull-Rom class of splines.

Remarks
  Splines are bendy lines. You define a series of points, and the spline forms a smoother line between the points to eliminate the sharp angles.

  Catmull-Rom splines are a specialisation of the general Hermite spline. With a Hermite spline, you define the start and end point of the line, and 2 tangents, one at the start of the line and one at the end. The Catmull-Rom spline simplifies this by just asking you to define a series of points, and the tangents are created for you.

## Constructor & Destructor Documentation

## ◆ SimpleSpline()

Ogre::SimpleSpline::SimpleSpline | ( |  | ) |

## ◆ ~SimpleSpline()

Ogre::SimpleSpline::~SimpleSpline | ( |  | ) |

## Member Function Documentation

## ◆ addPoint()

void Ogre::SimpleSpline::addPoint | ( | const Vector3 & | p | ) |

Adds a control point to the end of the spline.

## ◆ clear()

void Ogre::SimpleSpline::clear | ( |  | ) |

Clears all the points in the spline.

## ◆ getNumPoints()

unsigned short Ogre::SimpleSpline::getNumPoints | ( |  | ) | const

Gets the number of control points in the spline.

## ◆ getPoint()

const Vector3 & Ogre::SimpleSpline::getPoint | ( | unsigned short | index | ) | const

Gets the detail of one of the control points of the spline.

## ◆ interpolate() [1/2]

Vector3 Ogre::SimpleSpline::interpolate | ( | Real | t | ) | const

Returns an interpolated point based on a parametric value over the whole series.

Remarks
  Given a t value between 0 and 1 representing the parametric distance along the whole length of the spline, this method returns an interpolated point.

Parameters

  t | Parametric value.

## ◆ interpolate() [2/2]

Vector3 Ogre::SimpleSpline::interpolate | ( | unsigned int | fromIndex,
|  | Real | t ) const

Interpolates a single segment of the spline given a parametric value.

Parameters

  fromIndex | The point index to treat as t=0. fromIndex + 1 is deemed to be t=1
  t | Parametric value

## ◆ recalcTangents()

void Ogre::SimpleSpline::recalcTangents | ( |  | ) |

Recalculates the tangents associated with this spline.

Remarks
  If you tell the spline not to update on demand by calling setAutoCalculate(false) then you must call this after completing your updates to the spline points.

## ◆ setAutoCalculate()

void Ogre::SimpleSpline::setAutoCalculate | ( | bool | autoCalc | ) |

Tells the spline whether it should automatically calculate tangents on demand as points are added.

Remarks
  The spline calculates tangents at each point automatically based on the input points. Normally it does this every time a point changes. However, if you have a lot of points to add in one go, you probably don't want to incur this overhead and would prefer to defer the calculation until you are finished setting all the points. You can do this by calling this method with a parameter of 'false'. Just remember to manually call the recalcTangents method when you are done.

Parameters

  autoCalc | If true, tangents are calculated for you whenever a point changes. If false, you must call reclacTangents to recalculate them when it best suits.

## ◆ updatePoint()

void Ogre::SimpleSpline::updatePoint | ( | unsigned short | index,
|  | const Vector3 & | value )

Updates a single point in the spline.

Remarks
  This point must already exist in the spline.

The documentation for this class was generated from the following file:

- OgreSimpleSpline.h